// Generated by CoffeeScript 2.0.3
var anyplaying, autopilot_allowed, clamp, clips, current, dist, do_nothing, dragknob, dragoffset, dropknob, fakecursor, fakecursortimeout, getloaded, getvolumes, grabknob, ilerp, infoactivateing, infotoggle, init, initinfo, langs, langsdefault, lasttrioffset, lastuseraction, lerp, loadedfiles, loaderknoblang, loading, loadingpercent, main, mousepos, nothing, nothing_is_in, random, randomease, randomfrom, requestmedia, resize, set_volume, shuffle, sounds, subv2, switchinfolang, track, tracks, tri, tri_clamp, v2;

shuffle = function(a) {
  var i, j, m, ref, x;
  j = 0;
  x = 0;
  for (i = m = ref = a.length - 1; ref <= 1 ? m <= 1 : m >= 1; i = ref <= 1 ? ++m : --m) {
    j = Math.floor(Math.random() * (i + 1));
    x = a[i];
    a[i] = a[j];
    a[j] = x;
  }
  return a;
};

clips = shuffle(["cashier", "luggages", "packages", "road", "pigeons", "swing", "water", "subway", "box", "slide"]);

langsdefault = ["english", "italian", "hungarian"];

langs = shuffle([
  {
    english: "english",
    italian: "inglese",
    hungarian: "angol",
    loading: "loading"
  },
  {
    english: "italian",
    italian: "italiano",
    hungarian: "olasz",
    loading: "caricamento"
  },
  {
    english: "hungarian",
    italian: "ungherese",
    hungarian: "magyar",
    loading: "betöltés"
  }
]);

loadedfiles = {};

loadingpercent = function() {
  var a, f, fs, len, m;
  fs = Object.keys(loadedfiles);
  a = 0;
  for (m = 0, len = fs.length; m < len; m++) {
    f = fs[m];
    if (loadedfiles[f]) {
      a++;
    }
  }
  return a / fs.length;
};

v2 = class v2 {
  constructor(x1, y1) {
    this.x = x1;
    this.y = y1;
  }

};

tracks = {};

current = void 0;

infoactivateing = true;

dragoffset = new v2(0, 0);

nothing = false;

autopilot_allowed = true;

lasttrioffset = new v2(0, 0);

lastuseraction = 0;

mousepos = new v2(0, 0);

fakecursortimeout = 30000;

dist = function(a, b) {
  return Math.sqrt(Math.pow(a.x - b.x, 2) + Math.pow(a.y - b.y, 2));
};

clamp = function(a, b, p) {
  if (p < a) {
    return a;
  } else if (p > b) {
    return b;
  } else {
    return p;
  }
};

lerp = function(a, b, t) {
  return a * (1 - t) + b * t;
};

subv2 = function(a, b) {
  return new v2(a.x - b.x, a.y - b.y);
};

ilerp = function(a, b, p) {
  return (p - a) / (b - a);
};

random = function() {
  return -1 + Math.random() * 2;
};

randomfrom = function(ar) {
  if (ar.length > 0) {
    return ar[Math.round(Math.random() * (ar.length - 1))];
  } else {
    return void 0;
  }
};

randomease = function() {
  return randomfrom([
    "linear",
    "swing" //, "easeInOutQuad","easeInOutSine", "easeOutCubic", "easeOutQuint", "easeOutQuad"]
  ]);
};

tri_clamp = function(a, w, h, p) {
  p = new v2(clamp(a.x, a.x + w, p.x), clamp(a.y, a.y + h, p.y));
  if (p.x < a.x + w * 0.5) {
    p.x = clamp(lerp(a.x, a.x + w * 0.5, ilerp(a.y, a.y + h, p.y)), clamp(a.x, a.x + w * 0.5, p.x), p.x);
    p.y = clamp(a.y, a.y + h, p.y);
  } else {
    p.x = clamp(clamp(a.x + w * 0.5, a.x + w, p.x), lerp(a.x + w * 0.5, a.x + w, ilerp(a.y + h, a.y, p.y)), p.x);
    p.y = clamp(a.y, a.y + h, p.y);
  }
  return p;
};

tri = function() {
  var tr;
  tr = $("#control").offset();
  return [new v2(tr.left - 130, tr.top), new v2(tr.left + 130, tr.top), new v2(tr.left, tr.top + 210)];
};

getvolumes = function(p) {
  var d, ds, len, len1, len2, m, max, o, q, r, t, triangle;
  triangle = tri();
  for (m = 0, len = triangle.length; m < len; m++) {
    t = triangle[m];
    t.x += $("#control").width() * 0.5;
  }
  ds = [];
  for (o = 0, len1 = triangle.length; o < len1; o++) {
    t = triangle[o];
    ds.push(1 - clamp(0, 1, ilerp(0, 210, dist(p, t))));
  }
  r = [];
  max = ds.reduce(function(a, v) {
    if (v > a) {
      return v;
    } else {
      return a;
    }
  });
  for (q = 0, len2 = ds.length; q < len2; q++) {
    d = ds[q];
    r.push(d / max);
  }
  return r;
};

nothing_is_in = function(combo) {
  var bias, i, k, len, len1, len2, len3, m, matched, misplaced, normps, o, p, pi, q, t, tp, trgs, u;
  trgs = [new v2(0, 0), new v2(1, 0), new v2(0.5, 1), new v2(0.25, 0.5), new v2(0.5, 0), new v2(0.75, 0.5), new v2(0.375, 0.25), new v2(0.625, 0.25), new v2(0.5, 0.5), new v2(0.5, 0.2625)];
  normps = combo.map(function(v) {
    return new v2(ilerp(0, 260, v.x), ilerp(0, 210, v.y));
  });
  misplaced = normps.length;
  bias = 0.042;
  for (m = 0, len = clips.length; m < len; m++) {
    k = clips[m];
    $(`#${tracks[k].name}_knob`).css("background-color", "");
  }
  for (pi = o = 0, len1 = normps.length; o < len1; pi = ++o) {
    p = normps[pi];
    matched = false;
    for (i = q = 0, len2 = trgs.length; q < len2; i = ++q) {
      tp = trgs[i];
      if (!matched) {
        if (typeof tp !== "string" && dist(tp, p) < bias) {
          matched = true;
          trgs[i] = tracks[clips[pi]].name;
          misplaced--;
        }
      }
    }
  }
  for (i = u = 0, len3 = trgs.length; u < len3; i = ++u) {
    t = trgs[i];
    if (typeof t === "string") {
      $(`#${t}_knob`).css("background-color", "#222");
    }
  }
  return misplaced === 0;
};

do_nothing = function() {
  var k, len, m;
  autopilot_allowed = false;
  nothing = true;
  $("#info").css("display", "block");
  $("#top, #bottom").animate({
    opacity: 0.0
  }, 1000);
  $("body, html").css("background-color", "#000");
  $("#tri").css("fill", "#111");
  console.log("doing nothing");
  for (m = 0, len = clips.length; m < len; m++) {
    k = clips[m];
    tracks[k].toggle(k);
    tracks[k].sounds.setvolumes([0, 0, 0]);
    $(`#${k}_knob`).css("display", "none");
  }
  tracks.nothing.position = new v2($("#control").offset().left + $("#control").width() * 0.5, 105 + $("#control").offset().top - $("#control").height() * 0.125);
  return tracks.nothing.toggle("nothing");
};

set_volume = function(x, y) {
  var combo, p, tr, volumes;
  tr = $("#control").offset();
  p = tri_clamp(new v2(tr.left, tr.top), 260, 210, new v2(x, y));
  volumes = getvolumes(p);
  tracks[current].sounds.setvolumes(volumes);
  $(`#${current}_knob`).css({
    left: `${p.x}px`,
    top: `${p.y}px`
  });
  tracks[current].position = p;
  if (clips.reduce((function(a, k) {
    if (!tracks[k].playing) {
      return false;
    } else {
      return a;
    }
  }), true)) {
    combo = clips.map(function(k) {
      return subv2(tracks[k].position, lasttrioffset);
    });
    if (!nothing && nothing_is_in(combo)) {
      return do_nothing();
    }
  }
};

requestmedia = function(n, format) {
  var req;
  req = new XMLHttpRequest();
  req.open('GET', `media/${n}.${format}`, true);
  req.responseType = "blob";
  req.onload = function() {
    var blob;
    if (this.status === 200) {
      blob = this.response;
      console.log(`${n}.${format} finished loading`);
      loadedfiles[n] = true;
      return $(`#${n}`).attr("src", URL.createObjectURL(blob));
    }
  };
  return req.send();
};

sounds = (function() {
  class sounds {
    constructor(n) {
      var l, len, m, s, t;
      this.name = n;
      this.players = [];
      for (m = 0, len = langs.length; m < len; m++) {
        l = langs[m];
        t = `${n}_${l.english[0]}`;
        s = $("<audio>", {
          id: t
        });
        $("body").append(s);
        // $(t).attr("preload", "auto")
        requestmedia(t, "mp3");
        this.players.push($(`#${t}`));
      }
    }

    toggle(playing) {
      var len, m, p, ref, results;
      if (!this.loaded) {
        this.loaded = true;
      }
      ref = this.players;
      results = [];
      for (m = 0, len = ref.length; m < len; m++) {
        p = ref[m];
        p.get(0).currentTime = $(`#${this.name}`).get(0).currentTime;
        if (playing) {
          results.push(p.get(0).play());
        } else {
          results.push(p.get(0).pause());
        }
      }
      return results;
    }

    setvolumes(vs) {
      var i, len, m, p, ref, results;
      ref = this.players;
      results = [];
      for (i = m = 0, len = ref.length; m < len; i = ++m) {
        p = ref[i];
        results.push(p.get(0).volume = vs[i]);
      }
      return results;
    }

  };

  sounds.prototype.players = [];

  sounds.prototype.name = "";

  sounds.prototype.loaded = false;

  return sounds;

})();

grabknob = function(k, n) {
  // p = new v2($(k).offset().left, $(k).offset().top)
  // mouse = new v2(e.clientX, e.clientY)
  // dragoffset = new v2(mouse.x - p.x - 25, mouse.y - p.y - 25)
  $(k).addClass("dragged");
  return current = n;
};

dragknob = function(x, y) {
  if (current !== void 0) {
    return set_volume(x, y);
  }
};

dropknob = function() {
  $(`#${current}_knob`).removeClass("dragged");
  return current = void 0;
};

track = (function() {
  class track {
    restart() {
      if (!this.loaded) {
        this.loaded = true;
      }
      this.video.get(0).currentTime = 0;
      this.video.get(0).play();
      return this.sounds.toggle(true);
    }

    createknob(p, n, knob) {
      var k, style;
      k = $("<div>", {
        id: `${this.name}_knob`,
        class: "knob",
        style: ""
      });
      style = {
        "border-radius": "0%",
        left: p.left + $(`#${n}`).width() * 0.5 + "px",
        top: p.top + $(`#${n}`).height() * 0.5 + "px",
        opacity: 0.4,
        width: `${100 / clips.length}%`,
        height: $(`#${n}`).height() + "px"
      };
      $("#control-container").append(k);
      $(knob).css(style);
      $(knob).mouseenter(function() {
        $(`#${n}`).css("filter", "brightness(130%)");
        return window.setTimeout((function() {
          return $(`#${n}`).css({
            "filter": "brightness(100%)"
          });
        }), 200);
      });
      $(knob).mousedown(function(e) {
        return grabknob(knob, n);
      });
      $(knob).mouseup(function() {
        return dropknob();
      });
      $(knob).animate({
        opacity: "0.8",
        left: `${tracks[n].position.x}px`,
        width: "50px",
        height: "50px",
        top: `${tracks[n].position.y}px`,
        "border-radius": "50%"
      }, 500);
      return $(`#${this.name}`).addClass("playing");
    }

    toggle(n) {
      var knob;
      this.playing = !this.playing;
      knob = `#${n}_knob`;
      if (this.playing) {
        this.video.get(0).play();
        this.createknob(this.video.offset(), this.name, knob);
        this.sounds.setvolumes(getvolumes(this.position));
      } else {
        $(`#${this.name}`).removeClass("playing");
        $(`#${this.name}_knob`).animate({
          opacity: "0.0"
        }, 300, function() {
          return $(knob).get(0).remove();
        });
        if ($(".knob").get(0) === void 0) {
          current = void 0;
        }
        this.video.get(0).pause();
      }
      return this.sounds.toggle(this.playing);
    }

    pick_pos() {
      var nt;
      nt = new v2(130 + $("#control").offset().left + (130 * random()), $("#control").offset().top + (105 * random()));
      nt = tri_clamp(new v2($("#control").offset().left, $("#control").offset().top), 260, 210, nt);
      return this.position = new v2(nt.x, nt.y);
    }

    constructor(n, x, w, parent) {
      var v;
      this.pick_pos();
      v = $("<video>", {
        id: n,
        style: `left : ${x}%; width:${w}%;` + (parent === "#bottom" ? "bottom:0" : "")
      });
      $(parent).append(v);
      // $("##{n}").attr("preload", "auto")
      // $("##{n}")[0].autoplay = true
      requestmedia(n, "mp4");
      this.video = $(`#${n}`);
      this.video.bind("ended", function() {
        return tracks[n].restart();
      });
      this.video.click(function() {
        return tracks[n].toggle(n);
      });
      this.video.get(0).volume = 0;
      this.sounds = new sounds(n);
      this.sounds.setvolumes([0, 0, 0]);
      this.name = n;
    }

  };

  track.prototype.video = {};

  track.prototype.sounds = [];

  track.prototype.loaded = false;

  track.prototype.name = "";

  track.prototype.position = new v2(0, 0);

  track.prototype.playing = false;

  return track;

})();

infotoggle = function() {
  var infoshowing;
  return infoshowing = !infoshowing;
};

// $("#info").css({"opacity":(if infoshowing then 1 else 0)})
// if infoshowing then $("#info").css("display", "block")
// else
// window.setTimeout((() -> $("#info").css("display","none")), 500)
getloaded = function() {
  var c, len, ls, m;
  ls = [];
  for (m = 0, len = clips.length; m < len; m++) {
    c = clips[m];
    ls.push(tracks[c].loaded);
    ls.push(tracks[c].sounds.loaded);
  }
  return ls.reduce((function(a, v) {
    if (v) {
      return a + 1;
    } else {
      return a;
    }
  }), 0);
};

resize = function() {
  var i, k, l, len, len1, m, newtrioffset, o, ref, s, triangle;
  console.log("resizing");
  newtrioffset = $("#control").offset();
  triangle = tri();
  for (i = m = 0, len = langs.length; m < len; i = ++m) {
    l = langs[i];
    s = {
      left: `${triangle[i].x + $("#control").width() * 0.5}px`,
      top: `${triangle[i].y}px`
    };
    if (i !== 2) {
      s.transform = "translate(-50%, -150%)";
    }
    $(`#${l.english}`).css(s);
  }
  ref = Object.keys(tracks);
  for (o = 0, len1 = ref.length; o < len1; o++) {
    k = ref[o];
    tracks[k].position = new v2(newtrioffset.left + tracks[k].position.x - lasttrioffset.x, newtrioffset.top + tracks[k].position.y - lasttrioffset.y);
    $(`#${tracks[k].name}_knob`).css({
      left: tracks[k].position.x,
      top: tracks[k].position.y
    });
  }
  return lasttrioffset = new v2(newtrioffset.left, newtrioffset.top);
};

//get set  offset position, change knobs
switchinfolang = function(l) {
  var i, len, m, results;
  results = [];
  for (m = 0, len = langs.length; m < len; m++) {
    i = langs[m];
    results.push($(`#${i.english}`).html(i[l]));
  }
  return results;
};

initinfo = function() {
  var i, l, len, linfo, m, results, triangle;
  triangle = tri();
  results = [];
  for (i = m = 0, len = langs.length; m < len; i = ++m) {
    l = langs[i];
    linfo = $("<div>", {
      class: "info-text",
      id: l.english,
      html: l.english
    });
    linfo.mouseenter(function(e) {
      return switchinfolang(e.currentTarget.id);
    });
    results.push($("#info").append(linfo));
  }
  return results;
};

// fakedrag = false
anyplaying = function(stopped = false) {
  var c, len, m, r;
  r = [];
  for (m = 0, len = clips.length; m < len; m++) {
    c = clips[m];
    if ((stopped ? !tracks[c].playing : tracks[c].playing)) {
      r.push(tracks[c].name);
    }
  }
  return r;
};

fakecursor = {
  p: new v2(0, 0),
  nexttime: 0,
  fading: 0,
  self: function() {
    return $("#fakecursor");
  },
  active: false,
  getdelay: function() {
    return 500 + 3000 * Math.random();
  },
  click: function(f) {
    var revert;
    revert = function() {
      return this.self().animate({
        "border-radius": "50%"
      }, 200);
    };
    this.self().animate({
      "border-radius": "10%"
    }, 200, revert);
    return f();
  },
  move: function(x, y, f = null) {
    var d, pp;
    pp = this.self().position();
    d = dist(new v2(x, y), new v2(pp.left, pp.top));
    return this.self().animate({
      left: x,
      top: y
    }, 400 + Math.random() * 1000, randomease(), f);
  },
  moverandom: function() {
    return this.move(window.innerWidth * Math.random(), window.innerHeight * Math.random());
  },
  moveontri: function() {
    var c, pp, r, tp, tr;
    c = new v2(window.innerWidth * 0.5, window.innerHeight * 0.5);
    r = Math.random() * ($("#control").width() * 0.5);
    pp = new v2(c.x + r * Math.sin(2 * Math.PI * Math.random()), c.y + r * Math.cos(2 * Math.PI * Math.random()));
    tr = $("#control").offset();
    tp = tri_clamp(new v2(tr.left, tr.top), 260, 210, pp);
    return this.move(tp.x, tp.y);
  },
  toggle: function(i) {
    var click, pp;
    pp = $(`#${i}`).offset();
    pp.left += $(`#${i}`).width() * 0.5 + random() * $(`#${i}`).height() * 0.25;
    pp.top += $(`#${i}`).height() * 0.5 + random() * $(`#${i}`).height() * 0.25;
    click = function() {
      var revert;
      revert = function() {
        fakecursor.self().animate({
          "border-radius": "50%"
        }, 200);
        return tracks[i].toggle(i);
      };
      return fakecursor.self().animate({
        "border-radius": "10%"
      }, 200, revert);
    };
    return this.move(pp.left, pp.top, click);
  },
  togglerandom: function() {
    var i;
    i = clips[Math.round(Math.random() * (clips.length - 1))];
    return this.toggle(randomfrom(clips));
  },
  faderandom: function() {
    var any, click, n;
    any = anyplaying();
    if (any.length !== 0) {
      n = randomfrom(any);
      this.p = new v2($(`#${n}_knob`).offset().left + $(`#${n}_knob`).width() * 0.5, $(`#${n}_knob`).offset().top + $(`#${n}_knob`).height() * 0.5);
      click = function() {
        var revert;
        revert = function() {
          grabknob(`#${n}_knob`, n);
          return fakecursor.moveontri();
        };
        return fakecursor.self().animate({
          "border-radius": "10%"
        }, 200, revert);
      };
      this.move(this.p.x, this.p.y, click);
      return this.fading = 1;
    } else {
      return this.togglerandom();
    }
  },
  activate: function() {
    console.log("starting fake cursor");
    this.p.x = mousepos.x;
    this.p.y = mousepos.y;
    this.self().css({
      left: this.p.x,
      top: this.p.y
    });
    this.self().animate({
      opacity: 1.0
    }, 1000, (function() {
      return fakecursor.self().css("display", "block");
    }));
    return this.active = true;
  },
  // $("body, video, div").css { cursor : "none"}
  hide: function() {
    console.log("fake cursor stopped");
    if (current !== void 0) {
      dropknob();
      this.self().animate({
        "border-radius": "50%"
      }, 200);
      this.fading = 0;
    }
    this.self().animate({
      "opacity": 0.0
    }, 1000, (function() {
      return fakecursor.self().css("display", "none");
    }));
    return this.active = false;
  },
  update: function() {
    var r, rr;
    this.p.x = this.self().offset().left + this.self().width() * 0.5;
    this.p.y = this.self().offset().top + this.self().height() * 0.5;
    if (this.fading > 0) {
      dragknob(this.p.x, this.p.y);
    }
    if (Date.now() > this.nexttime && !this.self().is(':animated')) {
      this.nexttime = Date.now() + this.getdelay();
      r = Math.round(Math.random() * 2);
      if (this.fading > 0) {
        switch (r) {
          case 2:
            if (this.fading > 1) {
              dropknob();
              this.self().animate({
                "border-radius": "50%"
              }, 200);
              return this.fading = 0;
            }
            break;
          default:
            this.fading++;
            return this.moveontri();
        }
      } else {
        rr = Math.random();
        if (rr < 0.5) {
          // playing = anyplaying()
          // if playing.length < 2 then @toggle(randomfrom(anyplaying(true)))
          // else if playing.length > clips.length * 0.5 then @toggle(randomfrom playing)
          // else @togglerandom()
          return this.togglerandom();
        } else {
          return this.faderandom();
        }
      }
    }
  }
};

main = function() {
  if (autopilot_allowed && lastuseraction + fakecursortimeout < Date.now() && !fakecursor.active) {
    fakecursor.activate();
  }
  if (fakecursor.active) {
    fakecursor.update();
  }
  return window.requestAnimationFrame(main);
};

loaderknoblang = 0;

loading = function() {
  var c, i, len, len1, loaded, m, o, p, q, ref, tr;
  loaded = loadingpercent();
  if (loaded === 1) {
    clips.push("nothing");
    for (m = 0, len = clips.length; m < len; m++) {
      c = clips[m];
      tracks[c].pick_pos();
      tracks[c].video.get(0).currentTime = 0;
      tracks[c].video.get(0).pause();
      ref = tracks[c].sounds.players;
      for (o = 0, len1 = ref.length; o < len1; o++) {
        p = ref[o];
        p.get(0).currentTime = 0;
        p.get(0).pause();
      }
      tracks[c].sounds.setvolumes(getvolumes(tracks[c].position));
    }
    clips.pop();
    $("#top, #bottom").animate({
      opacity: 1.0
    }, 2000);
    $("#loadpercent, .knob, #loading, #info").animate({
      opacity: 0.0
    }, 1000, (function() {
      return $("#loadpercent, .knob, #loading").remove();
    }));
    lastuseraction = Date.now();
    return main();
  } else {
    tr = tri();
    loaderknoblang = (loaderknoblang + 1) % 3;
    for (i = q = 0; q <= 2; i = ++q) {
      $(`#loaderknob${i}`).animate({
        left: tr[(loaderknoblang + i) % 3].x + $("#control").width() * 0.5,
        top: tr[(loaderknoblang + i) % 3].y
      }, 500, "linear", function() {
        $("#loading").html(`${langs[loaderknoblang].loading}`);
        return $("#loadpercent").html(`${Math.floor(100 * loaded)}%`);
      });
    }
    return window.setTimeout(loading, 1000);
  }
};

init = function() {
  var bottom, c, i, l, len, len1, len2, m, n, o, p, q, top, w, x;
  $(".knob").css({
    "border-radius": "50%",
    left: window.innerWidth * 0.5,
    top: window.innerHeight * 0.5
  });
  top = $("<div>", {
    id: "top",
    class: "videolane"
  });
  bottom = $("<div>", {
    id: "bottom",
    class: "videolane"
  });
  $("body").append([top, bottom]);
  $("#top, #bottom").css({
    opacity: 0.0
  });
  for (i = m = 0, len = clips.length; m < len; i = ++m) {
    n = clips[i];
    l = clips.length;
    x = i < l / 2 ? i * (100 / (l / 2)) : (i - (l / 2)) * (100 / (l / 2));
    w = 20;
    p = i < l / 2 ? "#top" : "#bottom";
    tracks[n] = new track(n, x, w, p);
  }
  tracks.nothing = new track("nothing", 0, 100, "body");
  initinfo();
  $(window).resize(resize);
  $("html").mousemove(function(e) {
    mousepos = new v2(e.clientX, e.clientY);
    lastuseraction = Date.now();
    if (fakecursor.active) {
      return fakecursor.hide();
    } else {
      return dragknob(e.clientX, e.clientY);
    }
  });
  $("*").mouseup(function() {
    $(`#${current}_knob`).removeClass("dragged");
    return current = void 0;
  });
  lasttrioffset = $("#control").offset();
  resize();
  clips.push("nothing");
  for (o = 0, len1 = clips.length; o < len1; o++) {
    c = clips[o];
    loadedfiles[c] = false;
    for (q = 0, len2 = langs.length; q < len2; q++) {
      l = langs[q];
      loadedfiles[c + "_" + l.english[0]] = false;
    }
  }
  clips.pop();
  return loading();
};

init();

//# sourceMappingURL=main.js.map
